import playerlib

_playerPairs = {}

# == HELPER FUNCTIONS ===================================
def getUniqueSteam(playerID):
    global _playerPairs

    if playerID == "0" or playerID == None or playerID == "None":
        return None
    
    if "STEAM" in str(playerID) or "BOT" in str(playerID):
        return playerID
        
    playerSteam = playerlib.getPlayer(playerID).attributes["steamid"]
    if "LAN" in playerSteam or "BOT" in playerSteam:
        playerSteam = playerSteam + playerlib.getPlayer(playerID).attributes["name"]

    _playerPairs[playerSteam] = playerlib.getPlayer(playerID).attributes["name"]

    return playerSteam

def getPlayerName(playerID):
    global _playerPairs
    
    steamID = getUniqueSteam(playerID)
    if steamID in _playerPairs.keys():
        if not steamID or steamID == "None":
            del _playerPairs[steamID]
            return None
        else:
            return _playerPairs[steamID]
    return None

def getPlayerPairs():
    global _playerPairs
    return _playerPairs
   
def setPlayerPairs(pairs):
    global _playerPairs
    _playerPairs = pairs 

def getMessage(achievementName, action, playerID):
    playerName = playerlib.getPlayer(playerID).attributes["name"]
    return ("The#green %s Achievement#default has been %s #green%s#default!" % (achievementName, action, playerName))  

def sortDictByValue(d):
    """ Returns the keys of dictionary d sorted by their values """
    items=d.items()
    backitems=[ [v[1],v[0]] for v in items]
    backitems.sort(reverse=True)
    return [ backitems[i][1] for i in range(0,len(backitems))]      
# =======================================================